//--------------------------------------------------------------------------------------
// File: ExGrid2.fx
//
// The effect file for the ExGrid2 sample.  
// 
// Copyright (c) Microsoft Corporation. All rights reserved.
//--------------------------------------------------------------------------------------

//--------------------------------------------------------------------------------------
// O[oϐ
// Global variables
//--------------------------------------------------------------------------------------
float4x4	worldMatrix;			// World matrix for object
float4x4	worldViewProjection;	// World * View * Projection matrix

float4x4	GridWorldMatrix;		// m_GridMat[x,y,z] * camera.WorldMatrix

// Cg
float3		g_LightDir		= normalize( float3( 0.2f, 1.0f, -0.2f) );	// [hԂł̌̕
float4		g_LightDiffuse	= { 1.0f, 1.0f, 1.0f, 1.0f };				// Cg̃fBt[YF(gU)

float4	g_LightAmbient	= { 0.6f, 0.6f, 0.6f, 1.0f };				// Cg̃ArGgF() (Œ)


// }eA:(n)
float4		g_MaterialAmbientColor;	// }eÃArGgF()

float		g_Len;			// Jƌ_̋

struct VS_OUTPUT
{
    float4 Position   : POSITION;   // _ʒu vertex position 
    float4 Diffuse    : COLOR0;     // _DiffuseF vertex diffuse color (note that COLOR0 is clamped from 0..1)
};


VS_OUTPUT RenderSceneVS( float4			vPos		: POSITION, 
                         float3			vNormal		: NORMAL,
						 uniform bool	bType )
{
    VS_OUTPUT	Output;
    float3		vNormalWorldSpace;
	float		Bright = 1.0f;
  
    // Transform the position from object space to homogeneous projection space
	Output.Position = mul( vPos, worldViewProjection );

	if( bType )
	{
		// RenderMesh (CeBOL)

		// Transform the normal from object space to world space    
		vNormalWorldSpace = normalize( mul(vNormal, (float3x3)worldMatrix) ); // normal (world space)
	    
		// Compute simple directional lighting equation
		float3 vTotalLightDiffuse = float3(0,0,0);

		vTotalLightDiffuse += g_LightDiffuse * max( 0, dot(vNormalWorldSpace, g_LightDir ));
			// dot(a, b); 2̃xNgab̓ςԂ܂B  
			// normalize(v); v  v ̒ŊKꂽxNgԂ܂B
	       
		Output.Diffuse.rgb = g_MaterialAmbientColor * vTotalLightDiffuse
		                   + g_MaterialAmbientColor * g_LightAmbient;   

		Output.Diffuse.a = 1.0f; 
	}
	else
	{
		// RenderPrimitive (CeBO)
		Output.Diffuse = g_MaterialAmbientColor;
	}

	// ̋ɂ̌(s)
	// f:[hSƃCg(1̃xNg)̋
	float f = dot( g_LightDir,  mul( vPos, GridWorldMatrix ) );
	if     ( f < -4 ) Bright = 0.64f;
	else if( f < -3 ) Bright = 0.68f;
	else if( f < -2 ) Bright = 0.72f;
	else if( f < -1 ) Bright = 0.76f;
	else if( f <  0 ) Bright = 0.80f;
	else if( f <  1 ) Bright = 0.84f;
	else if( f <  2 ) Bright = 0.88f;
	else if( f <  3 ) Bright = 0.92f;
	else if( f <  4 ) Bright = 0.96f;
//	else              Bright = 1.00f;


	// -----------------------------------------------
	// J̋(s)ɂ̌
	// g_Len = J̉sʒu
	if     ( Output.Position.z > g_Len+4 ) Bright = Bright - 0.09f;
	else if( Output.Position.z > g_Len+3 ) Bright = Bright - 0.08f;
	else if( Output.Position.z > g_Len+2 ) Bright = Bright - 0.07f;
	else if( Output.Position.z > g_Len+1 ) Bright = Bright - 0.06f;
	else if( Output.Position.z > g_Len   ) Bright = Bright - 0.05f;
	else if( Output.Position.z > g_Len-1 ) Bright = Bright - 0.04f;
	else if( Output.Position.z > g_Len-2 ) Bright = Bright - 0.03f;
	else if( Output.Position.z > g_Len-3 ) Bright = Bright - 0.02f;
	else if( Output.Position.z > g_Len-4 ) Bright = Bright - 0.01f;
//	else                                   Bright = Bright - 0.00f;

	Output.Diffuse.rgb = Output.Diffuse.rgb * Bright; 

    return Output;    
}

//--------------------------------------------------------------------------------------
// Techniques
//--------------------------------------------------------------------------------------

// Mesh\ Cg/sɂ閾邳ϊL
technique RenderMesh
{
    pass P0
    {          
		VertexShader = compile vs_1_1 RenderSceneVS( true );
    }
}

// Primitives\ sɂ閾邳ϊL
technique RenderPrimitive
{
    pass P0
    {          
		VertexShader = compile vs_1_1 RenderSceneVS( false );
    }
}
